<template>
  <v-sheet
    append
    v-show="formExpensesTable"
    v-model="formExpensesTable"
    class="ma-5"
  >
    <v-card>
      <v-card-title>
        <v-toolbar-title>{{ title }}</v-toolbar-title>
        <v-spacer />
        <v-btn icon @click="formExpensesTable = !formExpensesTable">
          <v-icon>mdi-close</v-icon>
        </v-btn>
      </v-card-title>
      <hr
        role="separator"
        aria-orientation="horizontal"
        class="v-divider theme--light"
      />
      <form>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12" md="6">
                <v-text-field
                  v-model="editedItem.no"
                  label="026-1234-7654"
                  type="string"
                  required
                >
                </v-text-field>
              </v-col>
              <v-col cols="12" md="6">
                <v-select
                  :items="storesExpenses"
                  item-text="name"
                  item-value="id"
                  v-model="editedItem.storesExpenses"
                  label="ร้านค้า"
                  return-object
                  required
                  :error-messages="storesErrors"
                  @input="$v.editedItem.storesExpenses.$touch()"
                  @blur="$v.editedItem.storesExpenses.$touch()"
                >
                  <template v-slot:append-outer>
                    <v-btn small to="/iexpenses/stores" target="_blank">
                      <v-icon dark> mdi-file-plus </v-icon>
                    </v-btn>
                  </template>
                </v-select>
              </v-col>
              <v-col cols="12" md="12">
                <v-autocomplete
                  v-model="editedItem.listExpenses"
                  :items="listExpenses"
                  :loading="loading"
                  :filter="customFilter"
                  chips
                  label="รายการสินค้า"
                  item-text="name"
                  item-value="id"
                  return-object
                  required
                  :error-messages="selectErrors"
                  @input="$v.editedItem.listExpenses.$touch()"
                  @blur="$v.editedItem.listExpenses.$touch()"
                >
                  <template v-slot:append-outer>
                    <v-btn small to="/iexpenses/list" target="_blank">
                      <v-icon dark> mdi-file-plus </v-icon>
                    </v-btn>
                  </template>
                  <template v-slot:selection="data">
                    <v-chip
                      v-bind="data.attrs"
                      :input-value="data.selected"
                      close
                      @click="data.select"
                      @click:close="remove(data.item)"
                    >
                      {{ data.item.name }}
                    </v-chip>
                  </template>
                  <template v-slot:item="data">
                    <template v-if="typeof data.item !== 'object'">
                      <v-list-item-content
                        v-text="data.item"
                      ></v-list-item-content>
                    </template>
                    <template v-else>
                      <v-list-item-content>
                        <v-list-item-title
                          v-html="data.item.name"
                        ></v-list-item-title>
                        <v-list-item-subtitle
                          v-html="data.item.detail"
                        ></v-list-item-subtitle>
                      </v-list-item-content>
                    </template>
                  </template>
                </v-autocomplete>
              </v-col>
              <v-col cols="12" md="6">
                <v-text-field
                  v-model="editedItem.amount"
                  label="จำนวน"
                  type="number"
                  required
                  :error-messages="amountErrors"
                  @input="$v.editedItem.amount.$touch()"
                  @blur="$v.editedItem.amount.$touch()"
                >
                </v-text-field>
              </v-col>
              <v-col cols="12" md="6">
                <v-select
                  :items="unitExpenses"
                  item-text="name"
                  item-value="id"
                  v-model="editedItem.unitExpenses"
                  label="หน่วย"
                  return-object
                  required
                  :error-messages="unittErrors"
                  @input="$v.editedItem.unitExpenses.$touch()"
                  @blur="$v.editedItem.unitExpenses.$touch()"
                >
                  <template v-slot:append-outer>
                    <v-btn small to="/iexpenses/unit" target="_blank">
                      <v-icon dark> mdi-file-plus </v-icon>
                    </v-btn>
                  </template>
                </v-select>
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12" md="6">
                <v-text-field
                  v-model="editedItem.price"
                  label="ราคารวม"
                  type="number"
                  prefix="฿"
                  required
                  :error-messages="priceErrors"
                  @input="$v.editedItem.price.$touch()"
                  @blur="$v.editedItem.price.$touch()"
                ></v-text-field>
              </v-col>
              <v-col cols="12" md="6">
                <v-menu
                  v-model="menu2"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  transition="scale-transition"
                  offset-y
                  min-width="290px"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      v-model="editedItem.date"
                      label="วันที่ซื้อสินค้า"
                      prepend-icon="mdi-calendar"
                      readonly
                      v-bind="attrs"
                      v-on="on"
                      :error-messages="dateErrors"
                      @input="$v.editedItem.date.$touch()"
                      @blur="$v.editedItem.date.$touch()"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    v-model="editedItem.date"
                    @input="menu2 = false"
                  ></v-date-picker>
                </v-menu>
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12" md="12">
                <v-text-field
                  v-model="editedItem.detail"
                  label="รายละเอียด"
                  required
                  :error-messages="detailErrors"
                  @input="$v.editedItem.detail.$touch()"
                  @blur="$v.editedItem.detail.$touch()"
                ></v-text-field>
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12" md="12">
                <v-text-field
                  clearable
                  v-model="editedItem.doc"
                  label="รูปภาพใบเสร็จ"
                  type="text"
                >
                  <template v-slot:append-outer>
                    <v-btn small to="/image/upload" target="_blank">
                      <v-icon dark> mdi-image-plus </v-icon>
                    </v-btn>
                  </template>
                </v-text-field>
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>

        <v-card-actions>
          <v-spacer />
          <v-btn color="light-blue darken-2" dark>Clear</v-btn>
          <v-btn :color="btnCollo" dark @click="handdleAddData">
            {{ title }}
          </v-btn>
        </v-card-actions>
      </form>
    </v-card>
  </v-sheet>
</template>
<script>
import { validationMixin } from 'vuelidate'
import {
  required,
  minLength,
  maxLength,
  email,
  integer,
} from 'vuelidate/lib/validators'

import Swal from 'sweetalert2'

import { mapState, mapActions, mapGetters } from 'vuex'

import getExpenses from '~/mixins/getExpenses'

export default {
  mixins: [validationMixin, getExpenses],
  validations: {
    editedItem: {
      detail: {
        required,
        // minLength: minLength(4),
      },
      amount: { required, integer },
      price: { required, integer },
      unitExpenses: { required },
      date: { required },
      listExpenses: { required },
      storesExpenses: { required },
    },
  },

  props: ['findLastID', 'itemUnit'],

  data: () => ({
    btnCollo: 'success',
    indexEdit: -1,
    checkbox: false,
    date: new Date().toISOString().substr(0, 10),
    menu2: false,
    loading: false,
    search: null,
    editedItem: {
      id: '',
      no: null,
      amountExpense: null,
      unit: '',
      price: null,
      date: null,
      detail: '',
      listExpenses: '',
      storesExpense: '',
      doc: '',
      auth: '',
    },
    listExpenses: [],
    unitExpenses: [],
    storesExpenses: [],
    objExpensetype: '', //รับค่า Object จาก Selecter
    defaultItem: {
      id: '',
      no: null,
      amount: null,
      unit: '',
      price: null,
      date: null,
      detail: '',
      listExpenses: '',
      stores: '',
      doc: '',
      auth: '',
    },
  }),
  beforeCreate() {},
  watch: {
    getExpensesList() {
      this.listExpenses = this.dataExpensesList
    },
    getExpensesUnit() {
      this.unitExpenses = this.dataExpensesUnit
    },
    getExpensesStores() {
      this.storesExpenses = this.dataExpensesStores
    },
    // price(){
    //   this.editedItem.price = Number(this.editedItem.price)
    // }
  },
  computed: {
    // validate
    amountErrors() {
      const errors = []
      if (!this.$v.editedItem.amount.$dirty) return errors
      !this.$v.editedItem.amount.required && errors.push('กรุณากรอกจำนวนสินค้า')
      !this.$v.editedItem.amount.integer && errors.push('กรุณากรอกเฉพาะตัวเลข')
      return errors
    },
    unittErrors() {
      const errors = []
      if (!this.$v.editedItem.unitExpenses.$dirty) return errors
      !this.$v.editedItem.unitExpenses.required &&
        errors.push('กรุณาเลือกหน่วย')
      return errors
    },
    storesErrors() {
      const errors = []
      if (!this.$v.editedItem.storesExpenses.$dirty) return errors
      !this.$v.editedItem.storesExpenses.required &&
        errors.push('กรุณาเลือกหน่วย')
      return errors
    },
    priceErrors() {
      const errors = []
      if (!this.$v.editedItem.price.$dirty) return errors
      !this.$v.editedItem.price.required && errors.push('กรุณากรอกราคาสินค้า')
      !this.$v.editedItem.price.integer && errors.push('กรุณากรอกเฉพาะตัวเลข')
      return errors
    },
    dateErrors() {
      const errors = []
      if (!this.$v.editedItem.date.$dirty) return errors
      !this.$v.editedItem.date.required && errors.push('กรุณากรอกสินค้า')
      return errors
    },
    detailErrors() {
      const errors = []
      if (!this.$v.editedItem.detail.$dirty) return errors
      !this.$v.editedItem.detail.required &&
        errors.push('กรุณากรอกรายละเอียดประเภทของค่าใช้จ่าย')
      return errors
    },
    selectErrors() {
      const errors = []
      if (!this.$v.editedItem.listExpenses.$dirty) return errors
      !this.$v.editedItem.listExpenses.required &&
        errors.push('กรุณาเลือกประเภทสินค้า')
      return errors
    },
    formExpensesTable: {
      get() {
        return this.$nuxt.$store.state.expensestable.formExpensesTable
      },
      set(newVal) {
        this.$store.commit('SET_FORM_EXPENSES_TABLE', newVal)
      },
    },
    title() {
      this.indexEdit = this.$nuxt.$store.state.expensestable.EditItem
      // this.typeExpenseslist = this.itemList
      // this.unitExpenses = this.itemUnit
      if (this.indexEdit === -1) {
        //เพิ่ม 2 (AddForm) การจัดการข้อความ "เพิ่มข้อมูล", ข้อความปุ่ม, สีปุ่ม
        this.btnCollo = 'success'
        // this.putFormadddata()
        return 'เพิ่มข้อมูล'
      } else {
        //แก้ไข 2 (AddForm) การจัดการข้อความ "เพิ่มข้อมูล", ข้อความปุ่ม, สีปุ่ม
        this.putFormeditdata()
        this.btnCollo = 'warning'
        return 'แก้ไขข้อมูล'
      }
    },
  },
  mounted() {},
  methods: {
    converttoInt() {
      this.editedItem.price = Number(this.editedItem.price)
      this.editedItem.amount = Number(this.editedItem.amount)
    },
    textPic() {},
    customFilter(item, queryText, itemText) {
      const textOne = item.name.toLowerCase()
      const textTwo = item.detail.toLowerCase()
      const searchText = queryText.toLowerCase()
      return (
        textOne.indexOf(searchText) > -1 || textTwo.indexOf(searchText) > -1
      )
    },
    remove(item) {
      const index = this.editedItem.listExpenses.name.indexOf(item)
      if (index > 0) this.editedItem.listExpenses.name.splice(index, 1)
      else this.editedItem.listExpenses = ''
    },
    putFormadddata() {
      //เพิ่ม 2.1 (AddForm) Set editItem ให้เป็นค่าว่าง พร้อมสำหรับกรอกข้อมูล
      this.editedItem = Object.assign({}, this.defaultItem)
    },
    putFormeditdata() {
      //แก้ไข 2.1 (AddForm) Set editItem จาก Parameter ที่ Commit เข้าใน Store จากนั้น ดึงค่าจาก Store โดยตรงมาใช้
      this.editedItem = Object.assign(
        {},
        this.$nuxt.$store.state.expensestable.EditData
      )
      // this.checkSelect = Object.assign(
      //   {},
      //   this.$nuxt.$store.state.expenseslist.EditData.typeExpenses
      // )
      // Object.values(this.checkSelect).forEach((val) => {
      //   this.editedItem.selecterExpenses = val.id
      // })
    },
    handdleAddData() {
      // this.typeExpenses = this.editedItem.typeExpenses
      //เพิ่ม 2.2 (AddForm) Click เพิ่ม
      // console.log('Last ID : ', this.findLastID)
      // console.log('edit: ', this.editedItem)
      this.editedItem.auth = this.$nuxt.$store.state.users.user.email
      this.converttoInt()
      //ตรวจสอบการ Input ค่า ครบ,ถูก

      this.$v.$touch()
      if (this.$v.$invalid) {
        console.log('กรอกข้อมูลไม่ถูกต้อง หรือ ไม่ครบ')
      } else {
        // const dataDate =

        if (this.indexEdit === -1) {
          // indexEdit != 1 (เพิ่ม)
          //เพิ่ม 2.3 (AddForm) Input ค่า ID, Email เข้าไปใน Edititem
          this.editedItem.id = this.findLastID
          // console.log('ก่อนdispath',this.editedItem)
          //เพิ่ม 2.4 (AddForm) dispatch ไปยัง Fnc เพิ่มข้อมูล
          this.$store
            .dispatch('addDataExpensesTable', {
              formVal: this.editedItem,
              // selectVal: this.objExpensetype,
            })
            .then(() => {
              // เคลียร์ค่าว่าง

              // console.log('ก่อนค่าว่าง',this.editedItem)
              this.editedItem = Object.assign({}, this.defaultItem)
              // console.log('หลังค่าว่าง',this.editedItem)
              const Toast = Swal.mixin({
                toast: true,
                position: 'top',
                showConfirmButton: false,
                timer: 2000,
                timerProgressBar: true,
                didOpen: (toast) => {
                  toast.addEventListener('mouseenter', Swal.stopTimer)
                  toast.addEventListener('mouseleave', Swal.resumeTimer)
                },
              })

              Toast.fire({
                icon: 'success',
                title: 'บันทึกข้อมูลสำเร็จ',
              })

              //เพิ่ม 2.4.1 (AddForm) Set Commit จัดการหน้า Form สำหรับเพิ่มข้อมูล
              this.$store.commit('SET_FORM_EXPENSES_TABLE', false)
            })
            .catch((error) => {
              setTimeout(() => {
                console.log('Error In Cilent:', error.code)
              }, 2000)
            })
        } else {
          // indexEdit == 1 (แก้ไข)
          Swal.fire({
            title: 'คุณแน่ใจหรือไม่',
            text: 'คุณต้องการแก้ไขข้อมูลนี้',
            icon: 'question',
            showCancelButton: true,
            confirmButtonColor: '#FB8C00',
            cancelButtonColor: '#0288D1',
            confirmButtonText: 'ใช่, แก้ไขข้อมูล',
            cancelButtonText: 'ยกเลิก',
          }).then((result) => {
            if (result.isConfirmed) {
              Swal.fire(
                'แก้ไขข้อมูล',
                'คุณได้แก้ไขข้อมูลเรียบร้อยแล้ว',
                'success'
              )
              //แก้ไข 2.2 (AddForm) dispatch พร้อม parameter "this.editItem" ไปยัง Fnc เพิ่มข้อมูล
              this.$store
                .dispatch('editDataExpensesTable', { formVal: this.editedItem })
                .then(() => {
                  //แก้ไข 2.2.1 (AddForm) Assign ค่าว่างเปล่าให้กับ "this.editemItem"
                  this.editedItem = Object.assign({}, this.defaultItem)
                  //แก้ไข 2.2.2 (AddForm) Set Commit จัดการหน้า Form สำหรับแก่ไขข้อมูล
                  this.$store.commit('SET_FORM_EXPENSES_TABLE', false)
                })
            }
          })
        }
      }
    },
  },
}
</script>
<style scoped>
.v-input {
  width: 100%;
}
</style>
